<template>
    <div class="d-flex flex-column justify-content-center full-height-bg">
        <div class="d-flex justify-content-center">
            <div class="card m-2" style="min-width: 450px; min-height: 450px; border-color: rgba(0,0,0,0.20)">
                <div class="card-body">
                    <form>

                        <div class="form-group row">
                            <span class="col-12 text-center logo"><i class="fas fa-bolt"></i></span>
                            <span class="col-12 text-center font-weight-light h3">REGISTER</span>
                        </div>

                        <div class="form-group row">
                            <label for="name" class="col-sm-4 col-form-label text-md-right">Name</label>

                            <div class="col-md-6">
                                <input id="name" type="text" v-bind:class="['form-control',  {'is-invalid' : validationError && validationError.name}]" name="name" value="" v-model="name" required autofocus>

                                <template v-if="validationError && validationError.name">
                                    <span class="invalid-feedback">
                                        <strong>{{ validationError.name[0] }}</strong>
                                    </span>
                                </template>
                            </div>
                        </div>

                        <div class="form-group row">
                            <label for="email" class="col-sm-4 col-form-label text-md-right">E-Mail Address</label>

                            <div class="col-md-6">
                                <input id="email" type="text" v-bind:class="['form-control',  {'is-invalid' : validationError && validationError.email}]" name="email" value="" v-model="email" required>

                                <template v-if="validationError && validationError.email">
                                    <span class="invalid-feedback">
                                        <strong>{{ validationError.email[0] }}</strong>
                                    </span>
                                </template>
                            </div>
                        </div>

                        <div class="form-group row">
                            <label class="col-sm-4 col-form-label text-md-right">Account Type</label>

                            <div class="col-md-6 row pr-0 mr-0">
                                <div class="col-12 pr-0 mb-2">
                                    <div v-bind:class="['card', 'account-type-card',  {'active' : accountType === 'advertiser'}]" v-on:click.prevent="accountTypeSelected('advertiser')">
                                        <div class="card-body p-2">
                                            Advertiser  <span class="float-right" v-if="accountType === 'advertiser'"><i class="fas fa-check"></i></span>
                                        </div>
                                    </div>
                                </div>

                                <div class="col-12 pr-0">
                                    <div v-bind:class="['card', 'account-type-card',  {'active' : accountType === 'publisher'}]" v-on:click.prevent="accountTypeSelected('publisher')">
                                        <div class="card-body p-2">
                                            Publisher <span class="float-right" v-if="accountType === 'publisher'"><i class="fas fa-check"></i></span>
                                        </div>
                                    </div>
                                </div>


                                <template v-if="validationError && validationError.account_type">
                                    <span class="text-small text-danger pl-3 pt-1">
                                        <strong>{{ validationError.account_type[0] }}</strong>
                                    </span>
                                </template>
                            </div>
                        </div>

                        <div class="form-group row">
                            <label for="password" class="col-md-4 col-form-label text-md-right">Password</label>

                            <div class="col-md-6">
                                <input id="password" type="password" v-bind:class="['form-control',  {'is-invalid' : validationError && validationError.password}]" name="password" v-model="password" required>

                                <template v-if="validationError && validationError.password">
                                    <span class="invalid-feedback">
                                        <strong>{{ validationError.password[0] }}</strong>
                                    </span>
                                </template>
                            </div>
                        </div>

                        <div class="form-group row">
                            <label for="confirm_password" class="col-md-4 col-form-label text-md-right">Confirm Password</label>

                            <div class="col-md-6">
                                <input id="confirm_password" type="password" class="form-control" name="password_confirmation" v-model="password_confirmation" required>

                                <template v-if="false">
                                    <span class="invalid-feedback">
                                        <strong>error</strong>
                                    </span>
                                </template>
                            </div>
                        </div>


                        <template v-if="success || fail">
                            <template v-if="success">
                                <div class="alert alert-success text-center" role="alert">
                                    {{ this.success.message }}
                                </div>
                            </template>

                            <template v-if="fail">
                                <div class="alert alert-danger text-center" role="alert">
                                    {{ this.fail.message }}
                                </div>
                            </template>
                        </template>

                        <div class="form-group row">
                            <div class="col-md-8 offset-md-4">
                                <a href="#" class="btn btn-outline-primary" v-on:click.prevent="register" v-if="!loading">Register</a>
                                <button class="btn btn-outline-primary" v-else disabled><i class="fas fa-spinner fa-spin"></i> Register</button>
                            </div>
                        </div>

                        <div class="form-group row">
                            <span class="col-md-8 offset-md-4 my-1">
                                <router-link to="/login">Already Registered? Login</router-link>
                            </span>
                        </div>

                        <div class="row">
                            <span class="col-12 text-center"><router-link to="/"><i class="fas fa-arrow-left"></i> Back To Home</router-link></span>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
    export default {
        data: function() {
            return {
                name: '',
                email: '',
                password: '',
                password_confirmation: '',
                accountType: '',

                // loading flag
                loading: false,

                // Success flag
                success: false,

                // Fail flag
                fail: false,

                // Validation Error
                validationError: '',
            }
        },
        methods: {
            register: function() {
                // Show loading
                this.loading = true;

                // Clear previous status message
                this.success = false;
                this.fail = false;
                this.validationError = '';

                // Check account type is selected
                if (!this.accountType) {
                    this.validationError = {
                        account_type: ['Select account type']
                    };

                    this.loading = false;

                    return;
                }


                // Send a request to the backend
                axios.post('/register', { 'name': this.name, 'email': this.email, 'password': this.password, 'password_confirmation': this.password_confirmation, 'account_type': this.accountType })
                    .then(response => {
                        // On Success
                        this.success = {
                            message: 'Registration Complete. Go to Login page.'
                        };
                    })
                    .catch(error => {
                        if (error.response) {
                            // The request was made and the server responded with a status code
                            // that falls out of the range of 2xx
                            console.log(error.response.status);
                            
                            // Handle validation errors
                            if (error.response.status == 422) {
                                this.validationError = error.response.data.errors;
                            } else {
                                this.fail = {
                                    message: 'Something went wrong. Check the log.'
                                };
                            }

                        } else if (error.request) {
                            // The request was made, but no response was received
                            console.log(error.request);

                            this.fail = {
                                message: 'Something went wrong. Check the log.'
                            };

                        } else {
                            // Something happened in setting up the request that triggered an error
                            console.log('Error', error.message);

                            this.fail = {
                                message: 'Something went wrong. Check the log.'
                            };
                        }
                    })
                    .then(e => {
                        // When all things are said and done
                        console.log('Im done.');

                        // Hide the loading
                        this.loading = false;
                    });

            },
            accountTypeSelected: function(accountType) {
                if (accountType === 'publisher') {
                    this.accountType = 'publisher';
                } else {
                    this.accountType = 'advertiser';
                }
            }
        },
        mounted() {
            console.log('Component mounted.')
        }
    }
</script>

<style scoped>
    body {
        background-color: #FFFFFF;
    }

    .full-height-bg {
        height: 100vh;
        background-color: #FFFFFF;
    }

    .logo {
        font-size: 3rem;
    }



    .account-type-card {
        z-index: 2;
        cursor: pointer;
    }

    .account-type-card:hover, .account-type-card.active {
        color: #fff;
        background: #3490dc !important;
    }

    @media (max-width: 576px) {
        .full-height-bg {
            height: 100vh;
        }
    }


</style>
